import { Parser } from 'lezer';
import { LezerLanguage, LanguageSupport } from '@codemirror/language';
import { styleTags, tags } from '@codemirror/highlight';
import { completeFromList } from '@codemirror/autocomplete';
import { EditorView } from '@codemirror/view';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = Parser.deserialize({
  version: 13,
  states: "!|QYQPOOOeQPO'#CiO|QPO'#CfOOQO'#Cm'#CmQYQPOOOYQPO,58{OYQPO,58{OYQPO,58{OYQPO,59QOOQO-E6g-E6gOOQO1G.g1G.gO!jQPO1G.gO!qQPO1G.gO!xQPO1G.lOOQO7+$W7+$W",
  stateData: "#W~O`OSPOS~ORROSROZQO~OUTOVUOWVOR]XS]XZ]X^]X~O[WO~OUTORTiSTiWTiZTi^TiXTi~OVTi~P!ROVUO~P!ROUTOVUOWVOX^O~O",
  goto: "!RbPPPPPcPPPPcPPkPPPq]ROSTUVWQSORXSSPOSQYTQZUQ[VR]W",
  nodeNames: "⚠ LineComment Program Identifier String BinaryExpression CompareOp LogicAnd LogicOr ) Function Keyword (",
  maxTerm: 17,
  skippedNodes: [0,1],
  repeatNodeCount: 1,
  tokenData: ")k~RkXY!vYZ!v]^!vpq!vqr#Xrs#dxy$Ryz$W}!O$]!Q![$]!]!^$q!^!_$|!_!`#X!`!a$|!c!d%U!d!q$]!q!r&r!r!}$]#R#S$]#T#U't#U#V$]#V#W(h#W#h$]#h#i)P#i#m$]#m#n(h#n#o$]~!{S`~XY!vYZ!v]^!vpq!v~#[P!_!`#_~#dOU~~#gTOr#drs#vs#O#d#O#P#{#P~#d~#{OS~~$OPO~#d~$WO[~~$]OX~~$bTR~}!O$]!Q![$]!c!}$]#R#S$]#T#o$]~$vQP~OY$qZ~$q~%RPU~!_!`#_~%ZVR~}!O$]!Q![$]!c!p$]!p!q%p!q!}$]#R#S$]#T#o$]~%uVR~}!O$]!Q![$]!c!f$]!f!g&[!g!}$]#R#S$]#T#o$]~&cTR~V~}!O$]!Q![$]!c!}$]#R#S$]#T#o$]~&wVR~}!O$]!Q![$]!c!t$]!t!u'^!u!}$]#R#S$]#T#o$]~'eTR~W~}!O$]!Q![$]!c!}$]#R#S$]#T#o$]~'yWR~}!O$]!Q![$]![!](c!c!}$]#R#S$]#T#i$]#i#j(h#j#o$]~(hOZ~~(mUR~}!O$]!Q![$]![!](c!c!}$]#R#S$]#T#o$]~)UVR~}!O$]!Q![$]![!](c!c!}$]#R#S$]#T#U(h#U#o$]",
  tokenizers: [0],
  topRules: {"Program":[0,2]},
  tokenPrec: 0
});

const papershiveLanguage = LezerLanguage.define({
    parser: parser.configure({
        props: [
            /* foldNodeProp.add({
              Application: foldInside
            }), */
            styleTags({
                Identifier: tags.variableName,
                String: tags.string,
                LineComment: tags.lineComment,
                "( )": tags.paren,
                LogicAnd: tags.logicOperator,
                LogicOr: tags.logicOperator,
                CompareOp: tags.compareOperator,
                Function: tags.function,
                "au: a: t: ta: y: c:": tags.keyword
            })
        ]
    }),
    languageData: {
        commentTokens: { line: ";" }
    }
});
const papershiveCompletion = papershiveLanguage.data.of({
    autocomplete: completeFromList([
        {
            label: "au:",
            type: "function",
            detail: "Authors",
            apply: (view, completion, from, to) => {
                console.log(EditorView, completion, from, to);
            }
        },
        { label: "a:", type: "function", detail: "Abstracts", apply: 'a:("")' },
        { label: "t:", type: "function", detail: "Titless" },
        { label: "ta:", type: "function", detail: "Titles and Abstracts" },
        { label: "y:", type: "function", detail: "Year" },
        { label: "c:", type: "function", detail: "Citations" },
        {
            label: "AND",
            type: "logicOperator"
        },
        { label: "OR", type: "logicOperator" }
    ])
});
function papershive() {
    return new LanguageSupport(papershiveLanguage, [papershiveCompletion]);
}

export { papershive, papershiveCompletion, papershiveLanguage };
